// TODO Reliable event to initially add links?

// -- Settings -- //

var metadataUrl = 'http://geonetwork.astuntechnology.com/geonetwork/srv/en/main.home?uuid=##uuid##';

// -- Plugin -- //

// Lookup of MapSource, Layer, UUID:
//  {
//         'National/AllMaps': {
//             'primary': '158dc850-13b0-4838-b7d2-9c4a3904e1a2'
//        }
//  }
var metadata = null;

// When the plugin is loade make a request for the
// metadata lookup, populate the metadata object and
// attempt to create links
jQuery.getJSON(
    'GetData.aspx?Type=DataFunc&ds=at_metadata&RequestType=XSL&xsl=xml/atJSONDatatable.xsl',
    function(data, status) {
        metadata = {};
        jQuery.each(data.data, function(idx, item) {
            metadata[item[1]] = metadata[item[1]] || {};
            metadata[item[1]][item[2]] = item[3];
        });
        addLinks();
    }
);

astun.app.signaller.listen("refreshShowMapCategories", function($evt, mapSource, type) {
    addLinks();
});

function addLinks() {
	// First remove any existing metadata links
	jQuery('div.atMainLayersGroup').find('.atMetadata').remove();
	// Attempt to add a link for each layer in the layer control
    jQuery('div.atMainLayersGroup li[aria-describedby]').each(function(idx, elm) {
        elm = jQuery(elm);
        var layerId = elm.attr('aria-describedby'),
            layerName = elm.attr('aria-labelledby'),
            uuid = getUuid(metadata, astun.mapWrapper.mapSource.mapName, layerId);
        if (uuid) {
            var ul = elm.find('div.atChkboxInrWpr div.atLayerOptions ul');
            ul.append(getHtml(getUrl(metadataUrl, uuid), layerName));
            Astun.JS.Common.fitParentToChildren(ul.get(0));
        }
    });
}

function getHtml(url, layerName) {
    var html = '<li class="atMetadata">'
    html += '<a href="' + url + '" target="_blank" title="View metadata for '+ layerName + '.">&nbsp;</a>'
    html += '</li>';
    return html;
}

function getUuid(metadata, mapSource, layerId) {
    var uuid = null;
    if (metadata && metadata[mapSource]) {
        uuid = metadata[mapSource][layerId];
    }
    return uuid;
}

function getUrl(urlTemplate, uuid) {
    return urlTemplate.replace(/##uuid##/g, uuid);
}
